﻿B4i=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=5.3
@EndOfDesignText@
'Code module

Sub Process_Globals
	Private CB As Object
	Private EN As String
	Private NaObj As NativeObject
	
	'MinVersion: iOS 11
	
	'Events:
	'TokenGenerated (Token As String, Error As String)
End Sub

Sub Initialize(Callback As Object, EventName As String)
	CB = Callback
	EN = EventName
	NaObj = Me
End Sub

Sub IsSupported As Boolean
	Return NaObj.RunMethod("IsSupported",Null).AsBoolean
End Sub

Sub GenerateToken
	NaObj.RunMethod("GenerateToken",Null)
End Sub

Private Sub TokenGenerated (Token As String, Error As String)
	CallSub3(CB,EN & "_TokenGenerated",Token,Error)
End Sub


#if Objc
@import DeviceCheck;

-(BOOL)IsSupported{
	return DCDevice.currentDevice.supported;
}

-(void)GenerateToken{
	[DCDevice.currentDevice generateTokenWithCompletionHandler:^(NSData * _Nullable token, NSError * _Nullable error) {
	
        if (error){
            [self.bi raiseEvent:nil event:@"tokengenerated::" params:@[@"",error.localizedDescription]];
        }else{
            NSString* TokenString = [token base64EncodedStringWithOptions:0];
            [self.bi raiseEvent:nil event:@"tokengenerated::" params:@[TokenString,@""]];
        }
    }];
}
#End If